#ifndef MEMPHYSWCSD_h
#define MEMPHYSWCSD_h 1

//Geant4
#include "G4VSensitiveDetector.hh"

//MEMPHYS
#include "MEMPHYS/MEMPHYSWCHit.hh"

class G4Step;
class G4HCofThisEvent;

class MEMPHYSWCSD : public G4VSensitiveDetector {
 public:
  MEMPHYSWCSD(G4String);
  virtual ~MEMPHYSWCSD();
  
  void   Initialize(G4HCofThisEvent*);
  G4bool ProcessHits(G4Step*, G4TouchableHistory*);
  G4bool ProcessHits_constStep(const G4Step*, G4TouchableHistory*);
  void   EndOfEvent(G4HCofThisEvent*);
  
 private:

  MEMPHYSWCHitsCollection* hitsCollection;
  std::map<int,int> PMTHitMap;   // Whether a PMT was hit already
  G4int HCID; //JEC 16/11/05 

};

#endif

